/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2009-2011 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


// default includes
#include <shiboken.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <destroylistener.h>
#include <typeresolver.h>
#include <typeinfo>
#include "pyside_qtcore_python.h"

#include "qtconcurrent_wrapper.h"

// Extra includes
#include <qtconcurrentreducekernel.h>
#include <qtconcurrentthreadengine.h>



// Target ---------------------------------------------------------

extern "C" {
static PyMethodDef Sbk_QtConcurrent_methods[] = {

    {0} // Sentinel
};

} // extern "C"

static int Sbk_QtConcurrent_traverse(PyObject* self, visitproc visit, void* arg)
{
    return reinterpret_cast<PyTypeObject*>(&SbkObject_Type)->tp_traverse(self, visit, arg);
}
static int Sbk_QtConcurrent_clear(PyObject* self)
{
    return reinterpret_cast<PyTypeObject*>(&SbkObject_Type)->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType Sbk_QtConcurrent_Type = { { {
    PyVarObject_HEAD_INIT(&SbkObjectType_Type, 0)
    /*tp_name*/             "PySide.QtCore.QtConcurrent",
    /*tp_basicsize*/        sizeof(SbkObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_HAVE_GC,
    /*tp_doc*/              0,
    /*tp_traverse*/         Sbk_QtConcurrent_traverse,
    /*tp_clear*/            Sbk_QtConcurrent_clear,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          Sbk_QtConcurrent_methods,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             reinterpret_cast<PyTypeObject*>(&SbkObject_Type),
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              0,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*priv_data*/           0
};
} //extern

PyObject* SbkPySide_QtCore_QtConcurrent_ReduceOption___and__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::QtConcurrent::ReduceOptions >::toPython(
        Shiboken::Converter< ::QtConcurrent::ReduceOptions>::toCpp(self)
        & Shiboken::Converter< ::QtConcurrent::ReduceOptions >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_QtConcurrent_ReduceOption___or__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::QtConcurrent::ReduceOptions >::toPython(
        Shiboken::Converter< ::QtConcurrent::ReduceOptions>::toCpp(self)
        | Shiboken::Converter< ::QtConcurrent::ReduceOptions >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_QtConcurrent_ReduceOption___xor__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::QtConcurrent::ReduceOptions >::toPython(
        Shiboken::Converter< ::QtConcurrent::ReduceOptions>::toCpp(self)
        ^ Shiboken::Converter< ::QtConcurrent::ReduceOptions >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtCore_QtConcurrent_ReduceOption___invert__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< QtConcurrent::ReduceOptions >::toPython(
        ~Shiboken::Converter< ::QtConcurrent::ReduceOptions >::toCpp(self)
    );
}

static PyObject* SbkPySide_QtCore_QtConcurrent_ReduceOption_long(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::QtConcurrent::ReduceOptions>::toCpp(v);
    return PyLong_FromLong(val);
}
static int SbkPySide_QtCore_QtConcurrent_ReduceOption__nonzero(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::QtConcurrent::ReduceOptions>::toCpp(v);
    return val != 0;
}

static PyNumberMethods SbkPySide_QtCore_QtConcurrent_ReduceOption_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    #ifndef IS_PY3K
    /* nb_divide */             0,
    #endif
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              SbkPySide_QtCore_QtConcurrent_ReduceOption__nonzero,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_QtConcurrent_ReduceOption___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_QtConcurrent_ReduceOption___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_QtConcurrent_ReduceOption___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_QtConcurrent_ReduceOption___or__,
    #ifndef IS_PY3K
    /* nb_coerce */             0,
    #endif
    /*nb_int*/                  SbkPySide_QtCore_QtConcurrent_ReduceOption_long,
    #ifdef IS_PY3K
    /*nb_reserved*/             0,
    /*nb_float*/                0,
    #else
    /*nb_long*/                 SbkPySide_QtCore_QtConcurrent_ReduceOption_long,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    #endif
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    #ifndef IS_PY3K
    /*nb_inplace_divide*/       0,
    #endif
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_QtConcurrent_ReduceOptions_Type = {
    PyVarObject_HEAD_INIT(&PyType_Type, 0)
    /*tp_name*/             "ReduceOptions",
    /*tp_basicsize*/        sizeof(PySideQFlagsObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_QtConcurrent_ReduceOption_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      &PySideQFlagsRichCompare,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              &PySideQFlagsNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};



void init_QtConcurrent(PyObject* module)
{
    SbkPySide_QtCoreTypes[SBK_QTCONCURRENT_IDX] = reinterpret_cast<PyTypeObject*>(&Sbk_QtConcurrent_Type);

    if (!Shiboken::ObjectType::introduceWrapperType(module, "QtConcurrent", "QtConcurrent",
        &Sbk_QtConcurrent_Type)) {
        return;
    }

    // Initialization of enums.

    // Initialization of enum 'ReduceOption'.
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QTCONCURRENT_REDUCEOPTION__IDX] = &SbkPySide_QtCore_QtConcurrent_ReduceOptions_Type;
    SbkPySide_QtCoreTypes[SBK_QTCONCURRENT_REDUCEOPTION_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_QtConcurrent_Type,
        "ReduceOption",
        "PySide.QtCore.QtConcurrent.ReduceOption",
        "QtConcurrent::ReduceOption",
        SbkPySide_QtCoreTypes[SBK_QFLAGS_QTCONCURRENT_REDUCEOPTION__IDX]);
    if (!SbkPySide_QtCoreTypes[SBK_QTCONCURRENT_REDUCEOPTION_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QTCONCURRENT_REDUCEOPTION_IDX],
        &Sbk_QtConcurrent_Type, "UnorderedReduce", (long) QtConcurrent::UnorderedReduce))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QTCONCURRENT_REDUCEOPTION_IDX],
        &Sbk_QtConcurrent_Type, "OrderedReduce", (long) QtConcurrent::OrderedReduce))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtCoreTypes[SBK_QTCONCURRENT_REDUCEOPTION_IDX],
        &Sbk_QtConcurrent_Type, "SequentialReduce", (long) QtConcurrent::SequentialReduce))
        return ;
    // End of 'ReduceOption' enum.


    qRegisterMetaType< ::QtConcurrent::ReduceOption >("QtConcurrent::ReduceOption");
    qRegisterMetaType< ::QtConcurrent::ReduceOptions >("QtConcurrent::ReduceOptions");
}
