/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2009-2011 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <destroylistener.h>
#include <typeresolver.h>
#include <typeinfo>
#include "pyside_qtgui_python.h"

#include "qstylehintreturnvariant_wrapper.h"

// Extra includes



// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QStyleHintReturnVariant_Init(PyObject* self, PyObject* args, PyObject* kwds)
{
    SbkObject* sbkSelf = reinterpret_cast<SbkObject*>(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QStyleHintReturnVariant >()))
        return -1;

    ::QStyleHintReturnVariant* cptr = 0;

    // Call function/method
    {

        if(!PyErr_Occurred()) {
            // QStyleHintReturnVariant()
            PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
            cptr = new ::QStyleHintReturnVariant();
            PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QStyleHintReturnVariant >(), cptr)) {
        delete cptr;
        return -1;
    }
    Shiboken::Object::setValidCpp(sbkSelf, true);
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyMethodDef Sbk_QStyleHintReturnVariant_methods[] = {

    {0} // Sentinel
};

static PyObject* Sbk_QStyleHintReturnVariant_get_variant(PyObject* self, void*)
{
    ::QStyleHintReturnVariant* cppSelf = 0;
    if (!Shiboken::Object::isValid(self))
        return 0;
    cppSelf = Shiboken::Converter< ::QStyleHintReturnVariant* >::toCpp(self);
    PyObject* value = Shiboken::Converter< ::QVariant >::toPython(cppSelf->variant);
    return value;
}
static int Sbk_QStyleHintReturnVariant_set_variant(PyObject* self, PyObject* value, void*)
{
    ::QStyleHintReturnVariant* cppSelf = 0;
    if (!Shiboken::Object::isValid(self))
        return 0;
    cppSelf = Shiboken::Converter< ::QStyleHintReturnVariant* >::toCpp(self);
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'variant' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QVariant >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'variant', 'QVariant' or convertible type expected");
        return -1;
    }

    cppSelf->variant = Shiboken::Converter< ::QVariant >::toCpp(value);

    return 0;
}

// Getters and Setters for QStyleHintReturnVariant
static PyGetSetDef Sbk_QStyleHintReturnVariant_getsetlist[] = {
    {const_cast<char*>("variant"), Sbk_QStyleHintReturnVariant_get_variant, Sbk_QStyleHintReturnVariant_set_variant},
    {0}  // Sentinel
};

} // extern "C"

static int Sbk_QStyleHintReturnVariant_traverse(PyObject* self, visitproc visit, void* arg)
{
    return reinterpret_cast<PyTypeObject*>(&SbkObject_Type)->tp_traverse(self, visit, arg);
}
static int Sbk_QStyleHintReturnVariant_clear(PyObject* self)
{
    return reinterpret_cast<PyTypeObject*>(&SbkObject_Type)->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType Sbk_QStyleHintReturnVariant_Type = { { {
    PyVarObject_HEAD_INIT(&SbkObjectType_Type, 0)
    /*tp_name*/             "PySide.QtGui.QStyleHintReturnVariant",
    /*tp_basicsize*/        sizeof(SbkObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          &SbkDeallocWrapper,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_HAVE_GC,
    /*tp_doc*/              0,
    /*tp_traverse*/         Sbk_QStyleHintReturnVariant_traverse,
    /*tp_clear*/            Sbk_QStyleHintReturnVariant_clear,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          Sbk_QStyleHintReturnVariant_methods,
    /*tp_members*/          0,
    /*tp_getset*/           Sbk_QStyleHintReturnVariant_getsetlist,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             Sbk_QStyleHintReturnVariant_Init,
    /*tp_alloc*/            0,
    /*tp_new*/              SbkObjectTpNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*priv_data*/           0
};
} //extern


void init_QStyleHintReturnVariant(PyObject* module)
{
    SbkPySide_QtGuiTypes[SBK_QSTYLEHINTRETURNVARIANT_IDX] = reinterpret_cast<PyTypeObject*>(&Sbk_QStyleHintReturnVariant_Type);

    if (!Shiboken::ObjectType::introduceWrapperType(module, "QStyleHintReturnVariant", "QStyleHintReturnVariant*",
        &Sbk_QStyleHintReturnVariant_Type, &Shiboken::callCppDestructor< ::QStyleHintReturnVariant >, (SbkObjectType*)SbkPySide_QtGuiTypes[SBK_QSTYLEHINTRETURN_IDX])) {
        return;
    }

    // Initialization of enums.

    // Initialization of enum 'StyleOptionVersion'.
    SbkPySide_QtGuiTypes[SBK_QSTYLEHINTRETURNVARIANT_STYLEOPTIONVERSION_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_QStyleHintReturnVariant_Type,
        "StyleOptionVersion",
        "PySide.QtGui.QStyleHintReturnVariant.StyleOptionVersion",
        "QStyleHintReturnVariant::StyleOptionVersion");
    if (!SbkPySide_QtGuiTypes[SBK_QSTYLEHINTRETURNVARIANT_STYLEOPTIONVERSION_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtGuiTypes[SBK_QSTYLEHINTRETURNVARIANT_STYLEOPTIONVERSION_IDX],
        &Sbk_QStyleHintReturnVariant_Type, "Version", (long) QStyleHintReturnVariant::Version))
        return ;
    // End of 'StyleOptionVersion' enum.

    // Initialization of enum 'StyleOptionType'.
    SbkPySide_QtGuiTypes[SBK_QSTYLEHINTRETURNVARIANT_STYLEOPTIONTYPE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_QStyleHintReturnVariant_Type,
        "StyleOptionType",
        "PySide.QtGui.QStyleHintReturnVariant.StyleOptionType",
        "QStyleHintReturnVariant::StyleOptionType");
    if (!SbkPySide_QtGuiTypes[SBK_QSTYLEHINTRETURNVARIANT_STYLEOPTIONTYPE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtGuiTypes[SBK_QSTYLEHINTRETURNVARIANT_STYLEOPTIONTYPE_IDX],
        &Sbk_QStyleHintReturnVariant_Type, "Type", (long) QStyleHintReturnVariant::Type))
        return ;
    // End of 'StyleOptionType' enum.


    Shiboken::TypeResolver::createObjectTypeResolver< ::QStyleHintReturnVariant >("QStyleHintReturnVariant*");
    Shiboken::TypeResolver::createObjectTypeResolver< ::QStyleHintReturnVariant >(typeid(::QStyleHintReturnVariant).name());
    qRegisterMetaType< ::QStyleHintReturnVariant::StyleOptionVersion >("QStyleHintReturnVariant::StyleOptionVersion");
    qRegisterMetaType< ::QStyleHintReturnVariant::StyleOptionType >("QStyleHintReturnVariant::StyleOptionType");
}
