/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2009-2011 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


// default includes
#include <shiboken.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <destroylistener.h>
#include <typeresolver.h>
#include <typeinfo>
#include "pyside_qtnetwork_python.h"

#include "qssl_wrapper.h"

// Extra includes
#include <qssl.h>



// Target ---------------------------------------------------------

extern "C" {
static PyMethodDef Sbk_QSsl_methods[] = {

    {0} // Sentinel
};

} // extern "C"

static int Sbk_QSsl_traverse(PyObject* self, visitproc visit, void* arg)
{
    return reinterpret_cast<PyTypeObject*>(&SbkObject_Type)->tp_traverse(self, visit, arg);
}
static int Sbk_QSsl_clear(PyObject* self)
{
    return reinterpret_cast<PyTypeObject*>(&SbkObject_Type)->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType Sbk_QSsl_Type = { { {
    PyVarObject_HEAD_INIT(&SbkObjectType_Type, 0)
    /*tp_name*/             "PySide.QtNetwork.QSsl",
    /*tp_basicsize*/        sizeof(SbkObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_HAVE_GC,
    /*tp_doc*/              0,
    /*tp_traverse*/         Sbk_QSsl_traverse,
    /*tp_clear*/            Sbk_QSsl_clear,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          Sbk_QSsl_methods,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             reinterpret_cast<PyTypeObject*>(&SbkObject_Type),
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              0,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*priv_data*/           0
};
} //extern


void init_QSsl(PyObject* module)
{
    SbkPySide_QtNetworkTypes[SBK_QSSL_IDX] = reinterpret_cast<PyTypeObject*>(&Sbk_QSsl_Type);

    if (!Shiboken::ObjectType::introduceWrapperType(module, "QSsl", "QSsl",
        &Sbk_QSsl_Type)) {
        return;
    }

    // Initialization of enums.

    // Initialization of enum 'KeyType'.
    SbkPySide_QtNetworkTypes[SBK_QSSL_KEYTYPE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_QSsl_Type,
        "KeyType",
        "PySide.QtNetwork.QSsl.KeyType",
        "QSsl::KeyType");
    if (!SbkPySide_QtNetworkTypes[SBK_QSSL_KEYTYPE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtNetworkTypes[SBK_QSSL_KEYTYPE_IDX],
        &Sbk_QSsl_Type, "PrivateKey", (long) QSsl::PrivateKey))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtNetworkTypes[SBK_QSSL_KEYTYPE_IDX],
        &Sbk_QSsl_Type, "PublicKey", (long) QSsl::PublicKey))
        return ;
    // End of 'KeyType' enum.

    // Initialization of enum 'KeyAlgorithm'.
    SbkPySide_QtNetworkTypes[SBK_QSSL_KEYALGORITHM_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_QSsl_Type,
        "KeyAlgorithm",
        "PySide.QtNetwork.QSsl.KeyAlgorithm",
        "QSsl::KeyAlgorithm");
    if (!SbkPySide_QtNetworkTypes[SBK_QSSL_KEYALGORITHM_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtNetworkTypes[SBK_QSSL_KEYALGORITHM_IDX],
        &Sbk_QSsl_Type, "Rsa", (long) QSsl::Rsa))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtNetworkTypes[SBK_QSSL_KEYALGORITHM_IDX],
        &Sbk_QSsl_Type, "Dsa", (long) QSsl::Dsa))
        return ;
    // End of 'KeyAlgorithm' enum.

    // Initialization of enum 'SslProtocol'.
    SbkPySide_QtNetworkTypes[SBK_QSSL_SSLPROTOCOL_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_QSsl_Type,
        "SslProtocol",
        "PySide.QtNetwork.QSsl.SslProtocol",
        "QSsl::SslProtocol");
    if (!SbkPySide_QtNetworkTypes[SBK_QSSL_SSLPROTOCOL_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtNetworkTypes[SBK_QSSL_SSLPROTOCOL_IDX],
        &Sbk_QSsl_Type, "SslV3", (long) QSsl::SslV3))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtNetworkTypes[SBK_QSSL_SSLPROTOCOL_IDX],
        &Sbk_QSsl_Type, "SslV2", (long) QSsl::SslV2))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtNetworkTypes[SBK_QSSL_SSLPROTOCOL_IDX],
        &Sbk_QSsl_Type, "TlsV1", (long) QSsl::TlsV1))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtNetworkTypes[SBK_QSSL_SSLPROTOCOL_IDX],
        &Sbk_QSsl_Type, "AnyProtocol", (long) QSsl::AnyProtocol))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtNetworkTypes[SBK_QSSL_SSLPROTOCOL_IDX],
        &Sbk_QSsl_Type, "TlsV1SslV3", (long) QSsl::TlsV1SslV3))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtNetworkTypes[SBK_QSSL_SSLPROTOCOL_IDX],
        &Sbk_QSsl_Type, "SecureProtocols", (long) QSsl::SecureProtocols))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtNetworkTypes[SBK_QSSL_SSLPROTOCOL_IDX],
        &Sbk_QSsl_Type, "UnknownProtocol", (long) QSsl::UnknownProtocol))
        return ;
    // End of 'SslProtocol' enum.

    // Initialization of enum 'AlternateNameEntryType'.
    SbkPySide_QtNetworkTypes[SBK_QSSL_ALTERNATENAMEENTRYTYPE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_QSsl_Type,
        "AlternateNameEntryType",
        "PySide.QtNetwork.QSsl.AlternateNameEntryType",
        "QSsl::AlternateNameEntryType");
    if (!SbkPySide_QtNetworkTypes[SBK_QSSL_ALTERNATENAMEENTRYTYPE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtNetworkTypes[SBK_QSSL_ALTERNATENAMEENTRYTYPE_IDX],
        &Sbk_QSsl_Type, "EmailEntry", (long) QSsl::EmailEntry))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtNetworkTypes[SBK_QSSL_ALTERNATENAMEENTRYTYPE_IDX],
        &Sbk_QSsl_Type, "DnsEntry", (long) QSsl::DnsEntry))
        return ;
    // End of 'AlternateNameEntryType' enum.

    // Initialization of enum 'EncodingFormat'.
    SbkPySide_QtNetworkTypes[SBK_QSSL_ENCODINGFORMAT_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_QSsl_Type,
        "EncodingFormat",
        "PySide.QtNetwork.QSsl.EncodingFormat",
        "QSsl::EncodingFormat");
    if (!SbkPySide_QtNetworkTypes[SBK_QSSL_ENCODINGFORMAT_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtNetworkTypes[SBK_QSSL_ENCODINGFORMAT_IDX],
        &Sbk_QSsl_Type, "Pem", (long) QSsl::Pem))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtNetworkTypes[SBK_QSSL_ENCODINGFORMAT_IDX],
        &Sbk_QSsl_Type, "Der", (long) QSsl::Der))
        return ;
    // End of 'EncodingFormat' enum.


    qRegisterMetaType< ::QSsl::KeyType >("QSsl::KeyType");
    qRegisterMetaType< ::QSsl::KeyAlgorithm >("QSsl::KeyAlgorithm");
    qRegisterMetaType< ::QSsl::SslProtocol >("QSsl::SslProtocol");
    qRegisterMetaType< ::QSsl::AlternateNameEntryType >("QSsl::AlternateNameEntryType");
    qRegisterMetaType< ::QSsl::EncodingFormat >("QSsl::EncodingFormat");
}
