/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2009-2011 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


// default includes
#include <shiboken.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <destroylistener.h>
#include <typeresolver.h>
#include <typeinfo>
#include "pyside_qtsql_python.h"

#include "qsql_wrapper.h"

// Extra includes
#include <QtSql/qsql.h>



// Target ---------------------------------------------------------

extern "C" {
static PyMethodDef Sbk_QSql_methods[] = {

    {0} // Sentinel
};

} // extern "C"

static int Sbk_QSql_traverse(PyObject* self, visitproc visit, void* arg)
{
    return reinterpret_cast<PyTypeObject*>(&SbkObject_Type)->tp_traverse(self, visit, arg);
}
static int Sbk_QSql_clear(PyObject* self)
{
    return reinterpret_cast<PyTypeObject*>(&SbkObject_Type)->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType Sbk_QSql_Type = { { {
    PyVarObject_HEAD_INIT(&SbkObjectType_Type, 0)
    /*tp_name*/             "PySide.QtSql.QSql",
    /*tp_basicsize*/        sizeof(SbkObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_HAVE_GC,
    /*tp_doc*/              0,
    /*tp_traverse*/         Sbk_QSql_traverse,
    /*tp_clear*/            Sbk_QSql_clear,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          Sbk_QSql_methods,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             reinterpret_cast<PyTypeObject*>(&SbkObject_Type),
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              0,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*priv_data*/           0
};
} //extern

PyObject* SbkPySide_QtSql_QSql_ParamTypeFlag___and__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::QSql::ParamType >::toPython(
        Shiboken::Converter< ::QSql::ParamType>::toCpp(self)
        & Shiboken::Converter< ::QSql::ParamType >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtSql_QSql_ParamTypeFlag___or__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::QSql::ParamType >::toPython(
        Shiboken::Converter< ::QSql::ParamType>::toCpp(self)
        | Shiboken::Converter< ::QSql::ParamType >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtSql_QSql_ParamTypeFlag___xor__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< ::QSql::ParamType >::toPython(
        Shiboken::Converter< ::QSql::ParamType>::toCpp(self)
        ^ Shiboken::Converter< ::QSql::ParamType >::toCpp(pyArg)
    );
}

PyObject* SbkPySide_QtSql_QSql_ParamTypeFlag___invert__(PyObject* self, PyObject* pyArg)
{
    return Shiboken::Converter< QSql::ParamType >::toPython(
        ~Shiboken::Converter< ::QSql::ParamType >::toCpp(self)
    );
}

static PyObject* SbkPySide_QtSql_QSql_ParamTypeFlag_long(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::QSql::ParamType>::toCpp(v);
    return PyLong_FromLong(val);
}
static int SbkPySide_QtSql_QSql_ParamTypeFlag__nonzero(PyObject* v)
{
    long val = (long) Shiboken::Converter< ::QSql::ParamType>::toCpp(v);
    return val != 0;
}

static PyNumberMethods SbkPySide_QtSql_QSql_ParamTypeFlag_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    #ifndef IS_PY3K
    /* nb_divide */             0,
    #endif
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              SbkPySide_QtSql_QSql_ParamTypeFlag__nonzero,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtSql_QSql_ParamTypeFlag___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtSql_QSql_ParamTypeFlag___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtSql_QSql_ParamTypeFlag___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtSql_QSql_ParamTypeFlag___or__,
    #ifndef IS_PY3K
    /* nb_coerce */             0,
    #endif
    /*nb_int*/                  SbkPySide_QtSql_QSql_ParamTypeFlag_long,
    #ifdef IS_PY3K
    /*nb_reserved*/             0,
    /*nb_float*/                0,
    #else
    /*nb_long*/                 SbkPySide_QtSql_QSql_ParamTypeFlag_long,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    #endif
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    #ifndef IS_PY3K
    /*nb_inplace_divide*/       0,
    #endif
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtSql_QSql_ParamType_Type = {
    PyVarObject_HEAD_INIT(&PyType_Type, 0)
    /*tp_name*/             "ParamType",
    /*tp_basicsize*/        sizeof(PySideQFlagsObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtSql_QSql_ParamTypeFlag_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      &PySideQFlagsRichCompare,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              &PySideQFlagsNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};



void init_QSql(PyObject* module)
{
    SbkPySide_QtSqlTypes[SBK_QSQL_IDX] = reinterpret_cast<PyTypeObject*>(&Sbk_QSql_Type);

    if (!Shiboken::ObjectType::introduceWrapperType(module, "QSql", "QSql",
        &Sbk_QSql_Type)) {
        return;
    }

    // Initialization of enums.

    // Initialization of enum 'NumericalPrecisionPolicy'.
    SbkPySide_QtSqlTypes[SBK_QSQL_NUMERICALPRECISIONPOLICY_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_QSql_Type,
        "NumericalPrecisionPolicy",
        "PySide.QtSql.QSql.NumericalPrecisionPolicy",
        "QSql::NumericalPrecisionPolicy");
    if (!SbkPySide_QtSqlTypes[SBK_QSQL_NUMERICALPRECISIONPOLICY_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtSqlTypes[SBK_QSQL_NUMERICALPRECISIONPOLICY_IDX],
        &Sbk_QSql_Type, "LowPrecisionInt32", (long) QSql::LowPrecisionInt32))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtSqlTypes[SBK_QSQL_NUMERICALPRECISIONPOLICY_IDX],
        &Sbk_QSql_Type, "LowPrecisionInt64", (long) QSql::LowPrecisionInt64))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtSqlTypes[SBK_QSQL_NUMERICALPRECISIONPOLICY_IDX],
        &Sbk_QSql_Type, "LowPrecisionDouble", (long) QSql::LowPrecisionDouble))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtSqlTypes[SBK_QSQL_NUMERICALPRECISIONPOLICY_IDX],
        &Sbk_QSql_Type, "HighPrecision", (long) QSql::HighPrecision))
        return ;
    // End of 'NumericalPrecisionPolicy' enum.

    // Initialization of enum 'Location'.
    SbkPySide_QtSqlTypes[SBK_QSQL_LOCATION_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_QSql_Type,
        "Location",
        "PySide.QtSql.QSql.Location",
        "QSql::Location");
    if (!SbkPySide_QtSqlTypes[SBK_QSQL_LOCATION_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtSqlTypes[SBK_QSQL_LOCATION_IDX],
        &Sbk_QSql_Type, "BeforeFirstRow", (long) QSql::BeforeFirstRow))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtSqlTypes[SBK_QSQL_LOCATION_IDX],
        &Sbk_QSql_Type, "AfterLastRow", (long) QSql::AfterLastRow))
        return ;
    // End of 'Location' enum.

    // Initialization of enum 'ParamTypeFlag'.
    SbkPySide_QtSqlTypes[SBK_QFLAGS_QSQL_PARAMTYPEFLAG__IDX] = &SbkPySide_QtSql_QSql_ParamType_Type;
    SbkPySide_QtSqlTypes[SBK_QSQL_PARAMTYPEFLAG_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_QSql_Type,
        "ParamTypeFlag",
        "PySide.QtSql.QSql.ParamTypeFlag",
        "QSql::ParamTypeFlag",
        SbkPySide_QtSqlTypes[SBK_QFLAGS_QSQL_PARAMTYPEFLAG__IDX]);
    if (!SbkPySide_QtSqlTypes[SBK_QSQL_PARAMTYPEFLAG_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtSqlTypes[SBK_QSQL_PARAMTYPEFLAG_IDX],
        &Sbk_QSql_Type, "In", (long) QSql::In))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtSqlTypes[SBK_QSQL_PARAMTYPEFLAG_IDX],
        &Sbk_QSql_Type, "Out", (long) QSql::Out))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtSqlTypes[SBK_QSQL_PARAMTYPEFLAG_IDX],
        &Sbk_QSql_Type, "InOut", (long) QSql::InOut))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtSqlTypes[SBK_QSQL_PARAMTYPEFLAG_IDX],
        &Sbk_QSql_Type, "Binary", (long) QSql::Binary))
        return ;
    // End of 'ParamTypeFlag' enum.

    // Initialization of enum 'TableType'.
    SbkPySide_QtSqlTypes[SBK_QSQL_TABLETYPE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_QSql_Type,
        "TableType",
        "PySide.QtSql.QSql.TableType",
        "QSql::TableType");
    if (!SbkPySide_QtSqlTypes[SBK_QSQL_TABLETYPE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtSqlTypes[SBK_QSQL_TABLETYPE_IDX],
        &Sbk_QSql_Type, "Tables", (long) QSql::Tables))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtSqlTypes[SBK_QSQL_TABLETYPE_IDX],
        &Sbk_QSql_Type, "SystemTables", (long) QSql::SystemTables))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtSqlTypes[SBK_QSQL_TABLETYPE_IDX],
        &Sbk_QSql_Type, "Views", (long) QSql::Views))
        return ;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtSqlTypes[SBK_QSQL_TABLETYPE_IDX],
        &Sbk_QSql_Type, "AllTables", (long) QSql::AllTables))
        return ;
    // End of 'TableType' enum.


    qRegisterMetaType< ::QSql::NumericalPrecisionPolicy >("QSql::NumericalPrecisionPolicy");
    qRegisterMetaType< ::QSql::Location >("QSql::Location");
    qRegisterMetaType< ::QSql::ParamTypeFlag >("QSql::ParamTypeFlag");
    qRegisterMetaType< ::QSql::ParamType >("QSql::ParamType");
    qRegisterMetaType< ::QSql::TableType >("QSql::TableType");
}
