/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2009-2011 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <destroylistener.h>
#include <typeresolver.h>
#include <typeinfo>
#include "pyside_qtwebkit_python.h"

#include "qwebpage_errorpageextensionreturn_wrapper.h"

// Extra includes



// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QWebPage_ErrorPageExtensionReturn_Init(PyObject* self, PyObject* args, PyObject* kwds)
{
    SbkObject* sbkSelf = reinterpret_cast<SbkObject*>(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QWebPage::ErrorPageExtensionReturn >()))
        return -1;

    ::QWebPage::ErrorPageExtensionReturn* cptr = 0;
    int overloadId = -1;
    int numArgs = PyTuple_GET_SIZE(args);
    PyObject* pyArgs[] = {0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "ErrorPageExtensionReturn", 0, 1, &(pyArgs[0])))
        return -1;


    // Overloaded function decisor
    // 0: ErrorPageExtensionReturn()
    // 1: ErrorPageExtensionReturn(QWebPage::ErrorPageExtensionReturn)
    if (numArgs == 0) {
        overloadId = 0; // ErrorPageExtensionReturn()
    } else if (numArgs == 1
        && Shiboken::Converter< ::QWebPage::ErrorPageExtensionReturn >::isConvertible(pyArgs[0])) {
        overloadId = 1; // ErrorPageExtensionReturn(QWebPage::ErrorPageExtensionReturn)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QWebPage_ErrorPageExtensionReturn_Init_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // ErrorPageExtensionReturn()
        {

            if(!PyErr_Occurred()) {
                // ErrorPageExtensionReturn()
                PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                cptr = new ::QWebPage::ErrorPageExtensionReturn();
                PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
            }
            break;
        }
        case 1: // ErrorPageExtensionReturn(QWebPage::ErrorPageExtensionReturn)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QWebPage::ErrorPageExtensionReturn cppArg0 = Shiboken::Converter< ::QWebPage::ErrorPageExtensionReturn >::toCpp(pyArgs[0]);

            if(!PyErr_Occurred()) {
                // ErrorPageExtensionReturn(QWebPage::ErrorPageExtensionReturn)
                PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                cptr = new ::QWebPage::ErrorPageExtensionReturn(cppArg0);
                PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
            }
            break;
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QWebPage::ErrorPageExtensionReturn >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (!cptr) goto Sbk_QWebPage_ErrorPageExtensionReturn_Init_TypeError;

    Shiboken::Object::setValidCpp(sbkSelf, true);
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;

    Sbk_QWebPage_ErrorPageExtensionReturn_Init_TypeError:
        const char* overloads[] = {"", "PySide.QtWebKit.QWebPage::ErrorPageExtensionReturn", 0};
        Shiboken::setErrorAboutWrongArguments(args, "PySide.QtWebKit.ErrorPageExtensionReturn", overloads);
        return -1;
}

static PyObject* Sbk_QWebPage_ErrorPageExtensionReturn___copy__(PyObject* self)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    ::QWebPage::ErrorPageExtensionReturn& cppSelf = *(Shiboken::Converter< ::QWebPage::ErrorPageExtensionReturn* >::toCpp(self));
    PyObject* pyResult = Shiboken::Converter< ::QWebPage::ErrorPageExtensionReturn >::toPython(cppSelf);
    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return 0;
    }
    return pyResult;
}

static PyMethodDef Sbk_QWebPage_ErrorPageExtensionReturn_methods[] = {

    {"__copy__", (PyCFunction)Sbk_QWebPage_ErrorPageExtensionReturn___copy__, METH_NOARGS},
    {0} // Sentinel
};

static PyObject* Sbk_QWebPage_ErrorPageExtensionReturn_get_baseUrl(PyObject* self, void*)
{
    ::QWebPage::ErrorPageExtensionReturn* cppSelf = 0;
    if (!Shiboken::Object::isValid(self))
        return 0;
    cppSelf = Shiboken::Converter< ::QWebPage::ErrorPageExtensionReturn* >::toCpp(self);
    PyObject* value = Shiboken::Object::newObject((SbkObjectType*)SbkPySide_QtCoreTypes[SBK_QURL_IDX], &(cppSelf->baseUrl), false, true);
    Shiboken::Object::setParent(self, value);
    return value;
}
static int Sbk_QWebPage_ErrorPageExtensionReturn_set_baseUrl(PyObject* self, PyObject* value, void*)
{
    ::QWebPage::ErrorPageExtensionReturn* cppSelf = 0;
    if (!Shiboken::Object::isValid(self))
        return 0;
    cppSelf = Shiboken::Converter< ::QWebPage::ErrorPageExtensionReturn* >::toCpp(self);
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'baseUrl' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QUrl >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'baseUrl', 'QUrl' or convertible type expected");
        return -1;
    }

    cppSelf->baseUrl = Shiboken::Converter< ::QUrl >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QWebPage_ErrorPageExtensionReturn_get_contentType(PyObject* self, void*)
{
    ::QWebPage::ErrorPageExtensionReturn* cppSelf = 0;
    if (!Shiboken::Object::isValid(self))
        return 0;
    cppSelf = Shiboken::Converter< ::QWebPage::ErrorPageExtensionReturn* >::toCpp(self);
    PyObject* value = Shiboken::Converter< ::QString >::toPython(cppSelf->contentType);
    return value;
}
static int Sbk_QWebPage_ErrorPageExtensionReturn_set_contentType(PyObject* self, PyObject* value, void*)
{
    ::QWebPage::ErrorPageExtensionReturn* cppSelf = 0;
    if (!Shiboken::Object::isValid(self))
        return 0;
    cppSelf = Shiboken::Converter< ::QWebPage::ErrorPageExtensionReturn* >::toCpp(self);
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'contentType' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QString >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'contentType', 'QString' or convertible type expected");
        return -1;
    }

    cppSelf->contentType = Shiboken::Converter< ::QString >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QWebPage_ErrorPageExtensionReturn_get_encoding(PyObject* self, void*)
{
    ::QWebPage::ErrorPageExtensionReturn* cppSelf = 0;
    if (!Shiboken::Object::isValid(self))
        return 0;
    cppSelf = Shiboken::Converter< ::QWebPage::ErrorPageExtensionReturn* >::toCpp(self);
    PyObject* value = Shiboken::Converter< ::QString >::toPython(cppSelf->encoding);
    return value;
}
static int Sbk_QWebPage_ErrorPageExtensionReturn_set_encoding(PyObject* self, PyObject* value, void*)
{
    ::QWebPage::ErrorPageExtensionReturn* cppSelf = 0;
    if (!Shiboken::Object::isValid(self))
        return 0;
    cppSelf = Shiboken::Converter< ::QWebPage::ErrorPageExtensionReturn* >::toCpp(self);
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'encoding' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QString >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'encoding', 'QString' or convertible type expected");
        return -1;
    }

    cppSelf->encoding = Shiboken::Converter< ::QString >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QWebPage_ErrorPageExtensionReturn_get_content(PyObject* self, void*)
{
    ::QWebPage::ErrorPageExtensionReturn* cppSelf = 0;
    if (!Shiboken::Object::isValid(self))
        return 0;
    cppSelf = Shiboken::Converter< ::QWebPage::ErrorPageExtensionReturn* >::toCpp(self);
    PyObject* value = Shiboken::Object::newObject((SbkObjectType*)SbkPySide_QtCoreTypes[SBK_QBYTEARRAY_IDX], &(cppSelf->content), false, true);
    Shiboken::Object::setParent(self, value);
    return value;
}
static int Sbk_QWebPage_ErrorPageExtensionReturn_set_content(PyObject* self, PyObject* value, void*)
{
    ::QWebPage::ErrorPageExtensionReturn* cppSelf = 0;
    if (!Shiboken::Object::isValid(self))
        return 0;
    cppSelf = Shiboken::Converter< ::QWebPage::ErrorPageExtensionReturn* >::toCpp(self);
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'content' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QByteArray >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'content', 'QByteArray' or convertible type expected");
        return -1;
    }

    cppSelf->content = Shiboken::Converter< ::QByteArray >::toCpp(value);

    return 0;
}

// Getters and Setters for ErrorPageExtensionReturn
static PyGetSetDef Sbk_QWebPage_ErrorPageExtensionReturn_getsetlist[] = {
    {const_cast<char*>("baseUrl"), Sbk_QWebPage_ErrorPageExtensionReturn_get_baseUrl, Sbk_QWebPage_ErrorPageExtensionReturn_set_baseUrl},
    {const_cast<char*>("contentType"), Sbk_QWebPage_ErrorPageExtensionReturn_get_contentType, Sbk_QWebPage_ErrorPageExtensionReturn_set_contentType},
    {const_cast<char*>("encoding"), Sbk_QWebPage_ErrorPageExtensionReturn_get_encoding, Sbk_QWebPage_ErrorPageExtensionReturn_set_encoding},
    {const_cast<char*>("content"), Sbk_QWebPage_ErrorPageExtensionReturn_get_content, Sbk_QWebPage_ErrorPageExtensionReturn_set_content},
    {0}  // Sentinel
};

} // extern "C"

static int Sbk_QWebPage_ErrorPageExtensionReturn_traverse(PyObject* self, visitproc visit, void* arg)
{
    return reinterpret_cast<PyTypeObject*>(&SbkObject_Type)->tp_traverse(self, visit, arg);
}
static int Sbk_QWebPage_ErrorPageExtensionReturn_clear(PyObject* self)
{
    return reinterpret_cast<PyTypeObject*>(&SbkObject_Type)->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType Sbk_QWebPage_ErrorPageExtensionReturn_Type = { { {
    PyVarObject_HEAD_INIT(&SbkObjectType_Type, 0)
    /*tp_name*/             "PySide.QtWebKit.QWebPage.ErrorPageExtensionReturn",
    /*tp_basicsize*/        sizeof(SbkObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          &SbkDeallocWrapper,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_HAVE_GC,
    /*tp_doc*/              0,
    /*tp_traverse*/         Sbk_QWebPage_ErrorPageExtensionReturn_traverse,
    /*tp_clear*/            Sbk_QWebPage_ErrorPageExtensionReturn_clear,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          Sbk_QWebPage_ErrorPageExtensionReturn_methods,
    /*tp_members*/          0,
    /*tp_getset*/           Sbk_QWebPage_ErrorPageExtensionReturn_getsetlist,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             Sbk_QWebPage_ErrorPageExtensionReturn_Init,
    /*tp_alloc*/            0,
    /*tp_new*/              SbkObjectTpNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*priv_data*/           0
};
} //extern


void init_QWebPage_ErrorPageExtensionReturn(PyObject* enclosingClass)
{
    SbkPySide_QtWebKitTypes[SBK_QWEBPAGE_ERRORPAGEEXTENSIONRETURN_IDX] = reinterpret_cast<PyTypeObject*>(&Sbk_QWebPage_ErrorPageExtensionReturn_Type);

    if (!Shiboken::ObjectType::introduceWrapperType(enclosingClass, "ErrorPageExtensionReturn", "QWebPage::ErrorPageExtensionReturn",
        &Sbk_QWebPage_ErrorPageExtensionReturn_Type, &Shiboken::callCppDestructor< ::QWebPage::ErrorPageExtensionReturn >, (SbkObjectType*)SbkPySide_QtWebKitTypes[SBK_QWEBPAGE_EXTENSIONRETURN_IDX], 0, true)) {
        return;
    }


    Shiboken::TypeResolver::createValueTypeResolver< ::QWebPage::ErrorPageExtensionReturn >("QWebPage::ErrorPageExtensionReturn");
    Shiboken::TypeResolver::createObjectTypeResolver< ::QWebPage::ErrorPageExtensionReturn >("QWebPage::ErrorPageExtensionReturn*");
    Shiboken::TypeResolver::createValueTypeResolver< ::QWebPage::ErrorPageExtensionReturn >(typeid(::QWebPage::ErrorPageExtensionReturn).name());
    qRegisterMetaType< ::QWebPage::ErrorPageExtensionReturn >("ErrorPageExtensionReturn");
    qRegisterMetaType< ::QWebPage::ErrorPageExtensionReturn >("QWebPage::ErrorPageExtensionReturn");
}
